{{!-- psionics tab --}}
{{!-- #psionics - extract/set power items --}}
{{log "tab-psionics.hbs" this}}
<div class="psionic-tab-view">

    {{!-- #psionic --}}

    {{!-- psionic details dashbarod --}}
    {{> "systems/ars/templates/actor/parts/psionics-stats-block.hbs"}}

    {{!-- powers validation and psi combat selection --}}
    <div class="power-totals container-border" style="text-align: right;" data-tooltip="{{ localize 'ARS.psionics.used' }}">
        <span class="total-disciplines hide-1e{{#if this.actor.powerSummary.invalid.disciplines}} psi-invalid-total{{/if}}"><b>Diciplines:</b>
            <a>{{this.actor.powerSummary.summary.totalDisciplines}}</a></span>
        <span class="total-sciences{{#if this.actor.powerSummary.invalid.sciences}} psi-invalid-total{{/if}}"><b>Sciences:</b>
            <a>{{this.actor.powerSummary.summary.totalSciences}}</a></span>
        <span class="total-devotions{{#if this.actor.powerSummary.invalid.devotions}} psi-invalid-total{{/if}}"><b>Devotions:</b>
            <a>{{this.actor.powerSummary.summary.totalDevotions}}</a></span>
        <span class="total-defenses hide-1e{{#if this.actor.powerSummary.invalid.defenses}} psi-invalid-total{{/if}}"><b>Defenses:</b>
            <a>{{this.actor.powerSummary.summary.totalDefenseModes}}</a></span>
    </div>

    {{!-- psionic combat --}}
    <div class="psionic-combat-totals container-border hide-2e"
        style="text-align: right; {{#if this.actor.flags.ars.psionicCombatSegmentData}}display: block;{{else}}display: none;{{/if}}"
        data-tooltip="A characters total Psionic power for the begining of round">
        <span class="lbl-psi-segment-totals" style="margin-right: 15px;">Psychic Combat Segment Totals:</span>
        <span class="psi-combat-current-attack" style="margin-right: 10px;"><b>Total Psionic Strength:</b>
            <a>{{this.actor.flags.ars.psionicCombatSegmentData.totalPsionicStrength}}</a></span>
        <span class="psi-combat-current-attack" style="margin-right: 3px;"><b>Total Psionic Attack:</b>
            <a>{{this.actor.flags.ars.psionicCombatSegmentData.totalPsionicAttackStrength}}</a></span>
    </div>

    {{!-- maintained powers dashboard --}}
    {{#if this.actor.system.maintenancePowerEffects}}
    <div class="maintained-effect-list container-border">
        <div class="general-header maintained-power-header ars_clps{{#if (getViewState @root.actor.id (concat 'powers-maintained-' tab))}} ars_clps_on{{/if}}"
            data-vs-control="powers-maintained-{{tab}}">
            {{ localize 'ARS.psionics.maintained' }}
        </div>
        <div class="item-list ars_clps_container">
            {{!-- todo: create effect from here --}}
            {{!-- <li class="general-subheader flexrow ars_clps" data-effect-type="{{section.type}}">
                <div style="flex-grow:2;" class="effect-name flexrow">Name</div>
                <div class="effect-source">Source</div>
                <div class="item-controls effect-controls flexrow">
                    <a class="effect-control" data-action="create" data-tooltip='Create'> <i class="fas fa-plus"></i>Add</a>
                </div>
            </li> --}}

            <div class="general-subheader flexrow">
                <div class="item-name" style="flex: 1;">Name</div>
                <div style="flex: 1;">Cost</div>
                <div style="flex: 1;">Elapsed Time</div>
                <div style="flex: 1;"></div>
            </div>

            <ul class="maintained-list">
                {{#each this.actor.system.maintenancePowerEffects as |effect|}}
                {{#if effect.isVisible}}
                <li class="item effect flexrow" data-effect-id="{{effect.id}}" data-id="{{effect.id}}" data-effect-uuid="{{effect.uuid}}">
                    <img class="item-image" src="{{effect.img}}" />
                    <div class="item-name effect-name flexrow" style="flex: 2; text-align: left;">
                        <div class="text-trunc">{{effect.name}}</div>
                    </div>
                    <div class="effect-source text-trunc" data-tooltip="{{effect.formula}}" style="flex: 1; text-align: left;">
                        {{effect.formula}} / {{effect.rate}} {{effect.cycle}}
                    </div>
                    <div class="effect-source text-trunc" data-tooltip="{{effect.calculateEffectDuration}}" style="flex: 2;">
                        {{effect.calculateEffectDuration}}
                    </div>
                    {{#if (eq section.type 'temporary')}}
                    <div class="effect-source text-trunc">{{displayDuration effect}}</div>
                    {{/if}}
                    <div class="item-controls effect-controls flexrow" style="flex: 1;">
                        <a class="effect-control" data-action="toggle" data-tooltip='Toggle'>
                            <i style="margin-right:5px;" class="fas {{#if effect.disabled}}fa-toggle-off{{else}}fa-toggle-on{{/if}}"></i>
                        </a>
                        <a class="effect-control" data-action="edit" data-tooltip='Edit'>
                            <i class="fas fa-edit"></i>
                        </a>
                        <a class="effect-control" data-action="delete" data-tooltip='Delete'>
                            <i class="fas fa-trash"></i>
                        </a>
                    </div>
                </li>
                {{/if}}
                {{/each}}
            </ul>

        </div>
    </div>
    {{/if}}

    {{!-- defense modes active --}}
    {{#if this.actor.system.defensePowers}}
    <div class="maintained-effect-list container-border">
        <div class="general-header psionic-defenses-header ars_clps{{#if (getViewState @root.actor.id (concat 'powers-defenses-' tab))}} ars_clps_on{{/if}}"
            data-vs-control="powers-defenses-{{tab}}">
            {{ localize 'ARS.psionics.activedefenses' }}
        </div>
        <div class="item-list ars_clps_container">
            <div class="general-subheader flexrow">
                <div class="item-name" style="flex: 1;">Name</div>
                <div style="flex: 1;">Elapsed Time</div>
                <div style="flex: 1;"></div>
                <div style="flex: 1;"></div>
            </div>
            <ul class="maintained-list">
                {{#each this.actor.system.defensePowers as |effect|}}
                {{#if effect.isVisible}}
                <li class="item effect flexrow" data-effect-id="{{effect.id}}" data-id="{{effect.id}}" data-effect-uuid="{{effect.uuid}}">
                    <img class="item-image" src="{{effect.img}}" />
                    <div class="item-name effect-name flexrow" style="flex: 1; text-align: left;">
                        <div class="text-trunc">{{effect.name}}</div>
                    </div>
                    <div class="item-name effect-name flexrow" style="flex: 1;">
                        <div class="text-trunc">{{effect.calculateEffectDuration}}</div>
                    </div>
                    <div class="item-name effect-name flexrow" style="flex: 1;"></div>
                    <div class="item-controls effect-controls flexrow" style="flex: 1;">
                        <a class="effect-control" data-action="toggle" data-tooltip='Toggle'>
                            <i style="margin-right:5px;" class="fas {{#if effect.disabled}}fa-toggle-off{{else}}fa-toggle-on{{/if}}"></i>
                        </a>
                        <a class="effect-control" data-action="edit" data-tooltip='Edit'>
                            <i class="fas fa-edit"></i>
                        </a>
                        <a class="effect-control" data-action="delete" data-tooltip='Delete'>
                            <i class="fas fa-trash"></i>
                        </a>
                    </div>
                </li>
                {{/if}}
                {{/each}}
            </ul>
        </div>
    </div>
    {{/if}}

    {{!-- telepathic dashboard --}}
    {{#if this.actor.system.contactPowers}}
    <div class="maintained-effect-list container-border">
        <div class="general-header telepathic-contact-header ars_clps{{#if (getViewState @root.actor.id (concat 'powers-telepathic-contact-' tab))}} ars_clps_on{{/if}}"
            data-vs-control="powers-telepathic-contact-{{tab}}">
            {{ localize 'ARS.psionics.contact' }}
        </div>
        <div class="item-list ars_clps_container">
            <div class="general-subheader flexrow">
                <div class="item-name" style="flex: 1;">Name</div>
                <div style="flex: 1;">Tangent(s)</div>
                <div style="flex: 1;">Elapsed Time</div>
                <div style="flex: 1;">Target</div>
                <div style="flex: 1;"></div>
            </div>
            <ul class="maintained-list">
                {{#each this.actor.system.contactPowers as |effect|}}
                <li class="item effect flexrow" data-effect-id="{{effect.id}}" data-id="{{effect.id}}" data-effect-uuid="{{effect.uuid}}">
                    <img class="item-image" src="{{effect.img}}" />
                    <div class="item-name effect-name flexrow" style="flex: 1; text-align: left;">
                        <div class="text-trunc">{{effect.name}}</div>
                    </div>
                    <div class="effect-source text-trunc" style="flex: 1;">
                        {{effect.flags.psionics.tangentLabel}}
                    </div>
                    <div class="effect-source text-trunc" data-tooltip="{{effect.rate}} {{effect.cycle}}" style="flex: 1;">
                        {{effect.calculateEffectDuration}}
                    </div>
                    <div class="effect-source text-trunc" data-tooltip="{{effect.flags.psionics.tangentTarget}}">
                        {{effect.flags.psionics.tangentTarget}}
                    </div>
                    <div class="item-controls effect-controls flexrow" style="flex: 1;">
                        <a class="effect-control" data-action="toggle" data-tooltip='Toggle'>
                            <i style="margin-right:5px;" class="fas {{#if effect.disabled}}fa-toggle-off{{else}}fa-toggle-on{{/if}}"></i>
                        </a>
                        <a class="effect-control" data-action="edit" data-tooltip='Edit'>
                            <i class="fas fa-edit"></i>
                        </a>
                        <a class="effect-control" data-action="delete" data-tooltip='Delete'>
                            <i class="fas fa-trash"></i>
                        </a>
                    </div>
                </li>
                {{/each}}
            </ul>

        </div>
    </div>
    {{/if}}

    {{!-- psionic powers --}}
    {{#each this.actor.system.psionicsSorted as |item id|}}
    <div>
        <div class="general-header ars_clps{{#if (getViewState @root.actor.id (concat 'powers-' @key))}} ars_clps_on{{/if}}"
            data-vs-control="{{concat 'powers-' @key}}">
            {{capfirst (localize @key)}}
            <a class="item-control item-create" data-tooltip="Create item" data-type="power">
                <i class="fas fa-plus"></i>
            </a>
            <a class="sync-owned-powers" style="float: right; margin-right: 10px;" data-tooltip="Synchronize owned powers with source versions">
                <i class="fas fa-recycle"></i>
            </a>
        </div>
        <div class="ars_clps_container item-list">
            <div class="general-subheader flexrow">
                <div class="item-name">Name</div>
                <div>Category</div>
                <div class="hide-1e">Power Score</div>
                <div>Maintenance</div>
                <div class="hide-1e">PSP Cost</div>
                <div class="hide-2e">PSP Atk</div>
                <div class="hide-2e">PSP Def</div>
                <div class="item-controls"></div>
            </div>
            {{#each this}}
            <li class="item flexrow reveal-hidden info-item" data-id="{{this.id}}" data-type="{{this.type}}" data-uuid="{{this.uuid}}" style="height: 25px;">

                {{!-- init/image --}}
                {{#if (and @root.actor.needsInitiative @root.game.ars.config.settings.initiativeUseSpeed)}}
                {{#if @root.actor.combat.flags.ars.beginningOfRound}}
                <div class="initiative-roll-speed" data-tooltip="Roll initiative" role="button" aria-label="Roll initiative">
                    <i class="fas fa-dice"></i>
                </div>
                {{/if}}
                {{/if}}
                <div class="item-image" aria-label="{{this.name}}" style="background-image: url('{{this.img}}')">
                </div>

                {{!-- name --}}
                <div class="item-name rollable flexrow chatCard-roll" data-id="{{this.id}}" style="height: 25px; flex: 1;">
                    <div class="item-name text-trunc" style="height: 25px;">
                        <h4>{{this.name}}</h4>
                    </div>
                </div>

                {{!-- category --}}
                <div class="item-details text-trunc">{{this.system.powerCategory}}</div>

                {{!-- power score --}}
                <div class="text-trunc hide-1e">
                    {{localize (concat "ARS.abilityTypes." this.system.ability "abbr")}}
                    {{math (lookup (lookup @root.system.abilities this.system.ability) 'value') '+' this.system.abilityMod}}
                </div>

                {{!-- maintenance cost --}}
                <div class="item-details text-trunc">{{this.system.maintenance}}</div>

                {{!-- psp cost --}}
                <div class="item-details text-trunc hide-1e">{{this.system.powercost}}</div>
                <div class="item-details text-trunc hide-2e">{{this.system.powerCostAttack}}</div>
                <div class="item-details text-trunc hide-2e">{{this.system.powerCostDefense}}</div>

                {{!-- controls --}}
                <div class="item-controls">
                    <a class="item-control item-edit hidden" data-tooltip="Edit Item"><i class="fas fa-edit"></i></a>
                    <a class="item-control item-delete hidden" data-tooltip="Delete Item"><i class="fas fa-trash"></i></a>
                </div>
            </li>
            {{/each}}
        </div>
    </div>
    {{/each}}
</div>